#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <sstream>
#include <ctime>
#include <cmath>
#include <cstdlib>
using ll = long long;
using namespace std;

struct esh {
    ll x, y;
};

bool comparator(esh o1, esh o2) {
    return o1.x < o2.x;
}

void dfs(vector<vector<ll> > &a, ll start, vector<int> &used,ll stamina) {
    used[start] = 1;
    for (auto i: a[start]) {
        if (used[i] == 0&&stamina>0) {
            dfs(a, i, used,stamina-1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, m,k;
    cin >> n >> m>>k;
    vector<vector<ll> >a(n);
    ll r,l;
    for (ll i = 0; i < m; i++) {
        cin>>r>>l;
        a[r-1].push_back(l-1);
        a[l-1].push_back(r-1);
    }
    vector<int>used(n);
    vector<esh>security(k);
    for (ll i = 0; i < k; i++) {
        cin>>security[i].x>>security[i].y;
        security[i].x--;
    }
    for (int i = 0; i < k; i++) {
        dfs(a, security[i].x, used,security[i].y);
    }
    ll ans=0;
    for (ll i = 0; i < used.size(); i++) {
        if (used[i]==1) {
            ans++;
        }
    }cout<<ans<<"\n";
    for (ll i = 0; i < used.size(); i++) {
        if (used[i]==1) {cout<<i+1<<" ";}
    }
}
