#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <sstream>
#include <ctime>
#include <cmath>
#include <cstdlib>
#include <set>
using ll = long long;
using namespace std;

struct esh {
    double x, y;
};

bool comparator(esh o1, esh o2) {
    return o1.y > o2.y;
}

void dfs(vector<vector<ll> > &a, ll start, vector<esh> &used, ll stamina) {
    used[start].x = 1;
    used[start].y = stamina;
    for (auto i: a[start]) {
        if ((used[i].x == 0 || used[i].x == 2) && (stamina > used[i].y + 1 || (used[i].y == 0 && stamina > 0))) {
            dfs(a, i, used, stamina - 1);
        }
    }
    used[start].x = 2;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll o;
    cin>>o;
    double n, m = 0, k = 0, j;
    cin >> n >> m>>k>>j;
    cout<<sqrt((m-j)*(m-j)+(n-k)*(n-k));


}
