#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <sstream>
#include <ctime>
#include <cmath>
#include <cstdlib>
using ll = long long;
using namespace std;

struct esh {
    ll x, y;
};

bool comparator(esh o1, esh o2) {
    return o1.x < o2.x;
}

void dfs(vector<vector<ll> > &a, ll start, vector<int> &used) {
    used[start] = 1;
    for (auto i : a[start]) {
        if (used[i] == 0) {
            dfs(a, i, used);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n,m;
    cin >> m;
    for (ll i = 0; i < m; i++) {
        vector<ll>a(6);
        for (ll j = 0; j < 6; j++) {
            cin >> a[j];
        }
        sort(a.begin(), a.end());
        if(a[0]+a[5]!=a[1]+a[4]&&a[0]+a[5]!=a[2]+a[3]){cout<<"no"<<'\n';}
        else {
            cout<<"yes"<<"\n";
        }
    }

}
