#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <sstream>
#include <ctime>
#include <cmath>
#include <cstdlib>
using ll = long long;
using namespace std;

struct esh {
    ll x, y;
};

bool comparator(esh o1, esh o2) {
    return o1.x < o2.x;
}

void dfs(vector<vector<ll> > &a, ll start, vector<int> &used) {
    used[start] = 1;
    for (auto i: a[start]) {
        if (used[i] == 0) {
            dfs(a, i, used);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string n, m;
    cin >> n >> m;
    if (m.length() > n.length())swap(n, m);
    string sum;
    sum = n;
    ll diff;
    diff = n.length() - m.length();
    for (int i = 0; i < m.length(); ++i) {
        if (m[i] > sum[i + diff]) { sum[i + diff] = m[i]; }
    }
    cout << sum << " ";
    vector<int> d(m.length() + n.length() - 1);
    string s;
    int e = 0;
    int g = 0;
    for (int i = 0; i < m.length(); ++i) {
        e = m[m.length() - 1 - i] - '0';
        for (int j = 0; j < n.length(); ++j) {
            g = min(n[n.length() - 1 - j] - '0', e);
            d[d.size() - 1 - j-i] = max(d[d.size() - 1 - j-i], g);
        }
    }
    for (int i = 0; i < d.size(); ++i) {
        cout << d[i];
    }
}
