#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <sstream>
#include <ctime>
#include <cmath>
#include <cstdlib>
#include <set>
using ll = long long;
using namespace std;

struct esh {
    double x, y;
};

bool comparator(esh o1, esh o2) {
    return o1.y > o2.y;
}

void dfs(vector<vector<ll> > &a, ll start, vector<esh> &used, ll stamina) {
    used[start].x = 1;
    used[start].y = stamina;
    for (auto i: a[start]) {
        if ((used[i].x == 0 || used[i].x == 2) && (stamina > used[i].y + 1 || (used[i].y == 0 && stamina > 0))) {
            dfs(a, i, used, stamina - 1);
        }
    }
    used[start].x = 2;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, m = 0, k = 0;
    cin >> n >> m;
    cout << 'R';
    esh ans;
    ll del = 0;
    del = gcd(n, m);
    ans.x = n / del;
    ans.y = m / del;
    esh prev;
    prev.x = 1;
    prev.y = 1;
    esh vuborl = esh(0, 1);
    esh vuborr = esh(1, 0);
    string otvet;
    esh f;
    while (prev.x != ans.x || prev.y != ans.y) {
        if (ans.x / ans.y > prev.x / prev.y) {
            vuborl = prev;
            prev.x=prev.x+vuborr.x;
            prev.y=prev.y+vuborr.y;
            otvet.push_back('R');
        } else {
            vuborr = prev;
            prev.x=prev.x+vuborl.x;
            prev.y=prev.y+vuborl.y;
            otvet.push_back('L');
        }
    }
    cout << otvet;
}
